#include "dukterm.h"

duk_ret_t dukterm_initscr(duk_context *ctx) {
	if (initscr() != NULL) {
		dukterm_set_int(ctx, "LINES", LINES);
		dukterm_set_int(ctx, "COLS", COLS);
		return 0;
	} else {
		return DUK_RET_TYPE_ERROR;
	}
}
duk_ret_t dukterm_endwin(duk_context *ctx) {
	duk_push_int(ctx, endwin());
	return 1;
}
duk_ret_t dukterm_isendwin(duk_context *ctx) {
	duk_push_boolean(ctx, isendwin());
	return 1;
}

duk_ret_t dukterm_cbreak(duk_context *ctx) {
	duk_push_int(ctx, cbreak());
	return 1;
}
duk_ret_t dukterm_nocbreak(duk_context *ctx) {
	duk_push_int(ctx, nocbreak());
	return 1;
}
duk_ret_t dukterm_echo(duk_context *ctx) {
	duk_push_int(ctx, echo());
	return 1;
}
duk_ret_t dukterm_noecho(duk_context *ctx) {
	duk_push_int(ctx, noecho());
	return 1;
}
duk_ret_t dukterm_raw(duk_context *ctx) {
	duk_push_int(ctx, raw());
	return 1;
}
duk_ret_t dukterm_noraw(duk_context *ctx) {
	duk_push_int(ctx, noraw());
	return 1;
}
duk_ret_t dukterm_nl(duk_context *ctx) {
	duk_push_int(ctx, nl());
	return 1;
}
duk_ret_t dukterm_nonl(duk_context *ctx) {
	duk_push_int(ctx, nonl());
	return 1;
}
duk_ret_t dukterm_keypad(duk_context *ctx) {
	duk_push_int(ctx, keypad(stdscr, duk_to_boolean(ctx, -1)));
	return 1;
}
duk_ret_t dukterm_leaveok(duk_context *ctx) {
	duk_push_int(ctx, leaveok(stdscr, duk_to_boolean(ctx, -1)));
	return 1;
}
duk_ret_t dukterm_scrollok(duk_context *ctx) {
	duk_push_int(ctx, leaveok(stdscr, duk_to_boolean(ctx, -1)));
	return 1;
}

duk_ret_t dukterm_attron(duk_context *ctx) {
	duk_push_int(ctx, attron(duk_to_int(ctx, -1)));
	return 1;
}
duk_ret_t dukterm_attroff(duk_context *ctx) {
	duk_push_int(ctx, attroff(duk_to_int(ctx, -1)));
	return 1;
}
duk_ret_t dukterm_attrset(duk_context *ctx) {
	duk_push_int(ctx, attrset(duk_to_int(ctx, -1)));
	return 1;
}
duk_ret_t dukterm_standout(duk_context *ctx) {
	duk_push_int(ctx, standout());
	return 1;
}
duk_ret_t dukterm_standend(duk_context *ctx) {
	duk_push_int(ctx, standend());
	return 1;
}

duk_ret_t dukterm_color_set(duk_context *ctx) {
	duk_push_int(ctx, color_set(duk_to_int(ctx, -1), NULL));
	return 1;
}

duk_ret_t dukterm_has_colors(duk_context *ctx) {
	duk_push_boolean(ctx, has_colors());
	return 1;
}
duk_ret_t dukterm_start_color(duk_context *ctx) {
	int result = start_color();
	if (result == OK) {
		dukterm_set_int(ctx, "COLORS", COLORS);
		dukterm_set_int(ctx, "COLOR_PAIRS", COLOR_PAIRS);
		duk_push_int(ctx, result);
		return 1;
	} else {
		return DUK_RET_TYPE_ERROR;
	}
}
duk_ret_t dukterm_init_pair(duk_context *ctx) {
	int result = init_pair(
		duk_to_int(ctx, -3),
		duk_to_int(ctx, -2),
		duk_to_int(ctx, -1));
	if (result == OK) {
		duk_push_int(ctx, result);
		return 1;
	} else {
		return DUK_RET_TYPE_ERROR;
	}
}

duk_ret_t dukterm_getmaxx(duk_context *ctx) {
	duk_push_int(ctx, getmaxx(stdscr));
	return 1;
}
duk_ret_t dukterm_getmaxy(duk_context *ctx) {
	duk_push_int(ctx, getmaxy(stdscr));
	return 1;
}

duk_ret_t dukterm_erase(duk_context *ctx) {
	duk_push_int(ctx, erase());
	return 1;
}
duk_ret_t dukterm_clear(duk_context *ctx) {
	duk_push_int(ctx, clear());
	return 1;
}
duk_ret_t dukterm_refresh(duk_context *ctx) {
	duk_push_int(ctx, refresh());
	return 1;
}

duk_ret_t dukterm_move(duk_context *ctx) {
	int result = move(
		duk_to_int(ctx, -2),
		duk_to_int(ctx, -1));
	if (result == OK) {
		duk_push_int(ctx, result);
		return 1;
	} else {
		return DUK_RET_TYPE_ERROR;
	}
}
duk_ret_t dukterm_addstr(duk_context *ctx) {
	duk_push_int(ctx, addstr(duk_to_string(ctx, -1)));
	return 1;
}
duk_ret_t dukterm_addnstr(duk_context *ctx) {
	int result = addnstr(
		duk_to_string(ctx, -2),
		duk_to_int(ctx, -1));
	if (result == OK) {
		duk_push_int(ctx, result);
		return 1;
	} else {
		return DUK_RET_TYPE_ERROR;
	}
}
duk_ret_t dukterm_mvaddstr(duk_context *ctx) {
	int result = mvaddstr(
		duk_to_int(ctx, -3),
		duk_to_int(ctx, -2),
		duk_to_string(ctx, -1));
	if (result == OK) {
		duk_push_int(ctx, result);
		return 1;
	} else {
		return DUK_RET_TYPE_ERROR;
	}
}
duk_ret_t dukterm_mvaddnstr(duk_context *ctx) {
	int result = mvaddnstr(
		duk_to_int(ctx, -4),
		duk_to_int(ctx, -3),
		duk_to_string(ctx, -2),
		duk_to_int(ctx, -1));
	if (result == OK) {
		duk_push_int(ctx, result);
		return 1;
	} else {
		return DUK_RET_TYPE_ERROR;
	}
}

duk_ret_t dukterm_getch(duk_context *ctx) {
	int result = getch();
	if (result == KEY_RESIZE) {
		dukterm_set_int(ctx, "LINES", LINES);
		dukterm_set_int(ctx, "COLS", COLS);
	}
	duk_push_int(ctx, result);
	return 1;
}
duk_ret_t dukterm_key_fn(duk_context *ctx) {
	duk_push_int(ctx, KEY_F(duk_to_int(ctx, -1)));
	return 1;
}

const duk_function_list_entry dukterm_functions[] = {
    { "initscr", dukterm_initscr, 0 },
    { "endwin", dukterm_endwin, 0 },
    { "isendwin", dukterm_isendwin, 0 },

    { "cbreak", dukterm_cbreak, 0 },
    { "nocbreak", dukterm_nocbreak, 0 },
    { "echo", dukterm_echo, 0 },
    { "noecho", dukterm_noecho, 0 },
    { "raw", dukterm_raw, 0 },
    { "noraw", dukterm_noraw, 0 },
    { "nl", dukterm_nl, 0 },
    { "nonl", dukterm_nonl, 0 },
    { "keypad", dukterm_keypad, 1 },
    { "leaveok", dukterm_leaveok, 1 },
    { "scrollok", dukterm_scrollok, 1 },

    { "attron", dukterm_attron, 1 },
    { "attroff", dukterm_attroff, 1 },
    { "attrset", dukterm_attrset, 1 },
    { "standout", dukterm_standout, 0 },
    { "standend", dukterm_standend, 0 },

    { "color_set", dukterm_color_set, 1 },
    
    { "has_colors", dukterm_has_colors, 0 },
    { "start_color", dukterm_start_color, 0 },
    { "init_pair", dukterm_init_pair, 3 },

    { "getmaxx", dukterm_getmaxx, 0 },
    { "getmaxy", dukterm_getmaxy, 0 },

    { "erase", dukterm_erase, 0 },
    { "clear", dukterm_clear, 0 },
    { "refresh", dukterm_refresh, 0 },

    { "move", dukterm_move, 2 },
    { "addstr", dukterm_addstr, 1 },
    { "addnstr", dukterm_addnstr, 2 },
    { "mvaddstr", dukterm_mvaddstr, 3 },
    { "mvaddnstr", dukterm_mvaddnstr, 4 },

    { "getch", dukterm_getch, 0 },
    { "KEY_F", dukterm_key_fn, 1 },
    { NULL, NULL, 0 }
};

void dukterm_set_int(duk_context *ctx, char *name, int value) {
	duk_push_int(ctx, value);
	duk_put_global_string(ctx, name);
}

void dukterm_bind_const(duk_context *ctx) {
	dukterm_set_int(ctx, "OK", OK);
	dukterm_set_int(ctx, "ERR", ERR);

	dukterm_set_int(ctx, "A_NORMAL", A_NORMAL);
	dukterm_set_int(ctx, "A_STANDOUT", A_STANDOUT);
	dukterm_set_int(ctx, "A_UNDERLINE", A_UNDERLINE);
	dukterm_set_int(ctx, "A_REVERSE", A_REVERSE);
	dukterm_set_int(ctx, "A_BLINK", A_BLINK);
	dukterm_set_int(ctx, "A_DIM", A_DIM);
	dukterm_set_int(ctx, "A_BOLD", A_BOLD);
	dukterm_set_int(ctx, "A_PROTECT", A_PROTECT);
	dukterm_set_int(ctx, "A_INVIS", A_INVIS);
	dukterm_set_int(ctx, "A_ALTCHARSET", A_ALTCHARSET);
	
	dukterm_set_int(ctx, "COLOR_BLACK", COLOR_BLACK);
	dukterm_set_int(ctx, "COLOR_RED", COLOR_RED);
	dukterm_set_int(ctx, "COLOR_GREEN", COLOR_GREEN);
	dukterm_set_int(ctx, "COLOR_YELLOW", COLOR_YELLOW);
	dukterm_set_int(ctx, "COLOR_BLUE", COLOR_BLUE);
	dukterm_set_int(ctx, "COLOR_MAGENTA", COLOR_MAGENTA);
	dukterm_set_int(ctx, "COLOR_CYAN", COLOR_CYAN);
	dukterm_set_int(ctx, "COLOR_WHITE", COLOR_WHITE);

	dukterm_set_int(ctx, "KEY_RESIZE", KEY_RESIZE);

	dukterm_set_int(ctx, "KEY_BACKSPACE", KEY_BACKSPACE);
	dukterm_set_int(ctx, "KEY_ENTER", KEY_ENTER);
	dukterm_set_int(ctx, "KEY_BREAK", KEY_BREAK);

	dukterm_set_int(ctx, "KEY_UP", KEY_UP);
	dukterm_set_int(ctx, "KEY_DOWN", KEY_DOWN);
	dukterm_set_int(ctx, "KEY_LEFT", KEY_LEFT);
	dukterm_set_int(ctx, "KEY_RIGHT", KEY_RIGHT);
	dukterm_set_int(ctx, "KEY_HOME", KEY_HOME);
	dukterm_set_int(ctx, "KEY_END", KEY_END);
	dukterm_set_int(ctx, "KEY_PPAGE", KEY_PPAGE);
	dukterm_set_int(ctx, "KEY_NPAGE", KEY_NPAGE);
	dukterm_set_int(ctx, "KEY_DC", KEY_DC);
	dukterm_set_int(ctx, "KEY_IC", KEY_IC);

	dukterm_set_int(ctx, "KEY_F0", KEY_F0);
}

void dukterm_bind_to(duk_context *ctx) {
	dukterm_bind_const(ctx);
	
	duk_push_global_object(ctx);
	duk_put_function_list(ctx, -1, dukterm_functions);
	duk_pop(ctx);
}
