#ifndef dukterm_h
#define dukterm_h

#include <curses.h>
#include <duktape.h>

extern duk_ret_t dukterm_initscr(duk_context *ctx);
extern duk_ret_t dukterm_endwin(duk_context *ctx);
extern duk_ret_t dukterm_isendwin(duk_context *ctx);

extern duk_ret_t dukterm_cbreak(duk_context *ctx);
extern duk_ret_t dukterm_nocbreak(duk_context *ctx);
extern duk_ret_t dukterm_echo(duk_context *ctx);
extern duk_ret_t dukterm_noecho(duk_context *ctx);
extern duk_ret_t dukterm_raw(duk_context *ctx);
extern duk_ret_t dukterm_noraw(duk_context *ctx);
extern duk_ret_t dukterm_nl(duk_context *ctx);
extern duk_ret_t dukterm_nonl(duk_context *ctx);
extern duk_ret_t dukterm_keypad(duk_context *ctx);
extern duk_ret_t dukterm_leaveok(duk_context *ctx);
extern duk_ret_t dukterm_scrollok(duk_context *ctx);

extern duk_ret_t dukterm_attron(duk_context *ctx);
extern duk_ret_t dukterm_attroff(duk_context *ctx);
extern duk_ret_t dukterm_attrset(duk_context *ctx);
extern duk_ret_t dukterm_standout(duk_context *ctx);
extern duk_ret_t dukterm_standend(duk_context *ctx);

extern duk_ret_t dukterm_color_set(duk_context *ctx);

extern duk_ret_t dukterm_has_colors(duk_context *ctx);
extern duk_ret_t dukterm_start_color(duk_context *ctx);
extern duk_ret_t dukterm_init_pair(duk_context *ctx);

extern duk_ret_t dukterm_getmaxx(duk_context *ctx);
extern duk_ret_t dukterm_getmaxy(duk_context *ctx);

extern duk_ret_t dukterm_erase(duk_context *ctx);
extern duk_ret_t dukterm_clear(duk_context *ctx);
extern duk_ret_t dukterm_refresh(duk_context *ctx);

extern duk_ret_t dukterm_move(duk_context *ctx);
extern duk_ret_t dukterm_addstr(duk_context *ctx);
extern duk_ret_t dukterm_addnstr(duk_context *ctx);
extern duk_ret_t dukterm_mvaddstr(duk_context *ctx);
extern duk_ret_t dukterm_mvaddnstr(duk_context *ctx);

extern duk_ret_t dukterm_getch(duk_context *ctx);
extern duk_ret_t dukterm_key_fn(duk_context *ctx);

extern void dukterm_set_int(duk_context *ctx, char *name, int value);
extern void dukterm_bind_const(duk_context *ctx);
extern void dukterm_bind_to(duk_context *ctx);

#endif
